#include "Propriedade.h"
#include "NodoT.h"
#include "ListaT.h"

template<typename TIPO>
Lista<TIPO>::Lista()
{
  head = NULL;
}


template<typename TIPO>
Lista<TIPO>::Lista(Nodo<TIPO> *nhead)
{
  head = nhead;
}


template<typename TIPO>
void Lista<TIPO>::setHead(Nodo<TIPO> *nhead)
{
  head = nhead;
}


template<typename TIPO>
Nodo<TIPO> *Lista<TIPO>::getHead() const
{
  return (head);
}


// Busca o Nodo<TIPO> anterior aquele que tem o nome do Proprietario
template<typename TIPO>
Nodo<TIPO> *Lista<TIPO>::buscarPrev(const TIPO& nitem) const
{
  Nodo<TIPO> *prox = head, *prev;

  while (prox && prox->getItem() != nitem) {
    prev = prox;
    prox = prox->getProx();
  }

  if (!prox)
    prev = NULL;

  return(prev);
}




// Busca um Nodo<TIPO> pelo nome do Proprietario
template<typename TIPO>
Nodo<TIPO> *Lista<TIPO>::buscar(const TIPO& nitem) const
{
  Nodo<TIPO> *prox = head;

  while (prox && prox->getItem() != nitem)
    prox = prox->getProx();

  return(prox);
}


// Insere TIPO aps um Nodo<TIPO>
template<typename TIPO>
void Lista<TIPO>::inserir(TIPO& nitem, Nodo<TIPO> *prev)
{
  Nodo<TIPO> *prox;

  prox = new Nodo<TIPO>(nitem);
  prox->setProx(prev->getProx());
  prev->setProx(prox);

}


template<typename TIPO>
void Lista<TIPO>::remover(Nodo<TIPO> *prev)
{
  Nodo<TIPO> *remNodo;

  if (prev) {
    remNodo = prev->getProx();
    prev->setProx(remNodo->getProx());
    delete remNodo;
  }
}



// Adicionais

// Insere TIPO como a cabeca da lista
template<typename TIPO>
void Lista<TIPO>::inserir(TIPO& nitem)
{
  Nodo<TIPO> *prox;

  prox = new Nodo<TIPO>(nitem);
  prox->setProx(head);
  head = prox;
}


template<typename TIPO>
void Lista<TIPO>::remover(const TIPO& nitem)
{
  remover (buscarPrev(nitem));
}


template<typename TIPO>
int Lista<TIPO>::getNumItens() const
{
  int count = 0;
  Nodo<TIPO> *prox = head;

  while (prox) {
    count++;
    prox = prox->getProx();
  }

  return (count);
}


